require "pascal_config"

local normal_mode_init = true
local message_handlers = {}
local refresh_active = 0
local refresh_timer = nil
local status_timer = nil
local status_index = 0

message_handlers[pascal_Input_ID.PA_APP_REQUEST] = function (data)
	local mapargs = {}
	local request = 0
	
	request = bytes_to_int(data)
	
	if normal_mode_init then
		normal_mode_init = false
		mapargs["context_event_data"] = {id=pascal_Display_ID.PO_APP_STATE, len=1, b1=2}
		pascal_receive(mapargs)

    -- simulate anolyte and catholyte data
    mapargs["context_event_data"] = {id=pascal_Display_ID.PO_ANOLYTE_GENERATED, len=4, b1=54, b2=202, b3=0, b4=0}
    pascal_receive(mapargs)
    mapargs["context_event_data"] = {id=pascal_Display_ID.PO_CATHOLYTE_GENERATED, len=4, b1=67, b2=200, b3=0, b4=0}
    pascal_receive(mapargs)
    
    -- simulate ecell, manifold, and ph percents
    mapargs["context_event_data"] = {id=pascal_Display_ID.PO_ECELL_PERCENT, len=1, b1=100}
    pascal_receive(mapargs)
    mapargs["context_event_data"] = {id=pascal_Display_ID.PO_MANIFOLD_PERCENT, len=1, b1=11}
    pascal_receive(mapargs)
    mapargs["context_event_data"] = {id=pascal_Display_ID.PO_PH_PERCENT, len=1, b1=5}
    pascal_receive(mapargs)

    mapargs["context_event_data"] = {id=pascal_Display_ID.PO_PROBE_DELTA, len=3, b1=255, b2=23, b3=0}
    pascal_receive(mapargs)   
   
    mapargs["context_event_data"] = {id=pascal_Display_ID.PO_COMPONENT_WEAR_WARNING, len=1, b1=4}
    pascal_receive(mapargs)
        
    
    
    -- simuate task status
    mapargs["context_event_data"] = {id=pascal_Display_ID.PO_TASK_STATUS, len=10, b1=1, b2=1, b3=1, b4=1, b5=1,
                                                                                  b6=1, b7=1, b8=1, b9=1, b10=1 }
    pascal_receive(mapargs)
    
    mapargs["context_event_data"] = {id=pascal_Display_ID.PO_GUI_STATE, len=1, b1=5}
    pascal_receive(mapargs)
--    mapargs["context_event_data"] = {id=pascal_Display_ID.PO_CATHOLYTE_EMPTY_SWITCH, len=1, b1=0}
--    pascal_receive(mapargs)
--    mapargs["context_event_data"] = {id=pascal_Display_ID.PO_ANOLYTE_FULL_SWITCH, len=1, b1=0}
--    pascal_receive(mapargs)
--    mapargs["context_event_data"] = {id=pascal_Display_ID.PO_ANOLYTE_EMPTY_SWITCH, len=1, b1=1}
--    pascal_receive(mapargs)

    
    
    --simulate_status_updates()

		
		simulate_machine_refresh()
	end
	
	if (request == cPASCAL_REFRESH_REQ) then
    mapargs["context_event_data"] = {id=pascal_Display_ID.PO_APP_STATE, len=1, b1=2}
    pascal_receive(mapargs)
    simulate_machine_refresh()	
	end
	
end

function simulate_machine_refresh(mapargs)
  local mapargs = {}
  
  if refresh_timer ~= nil then
    gre.timer_clear_interval(refresh_timer) --Ensure there is only one timer running
    refresh_timer = nil
  end
  if (refresh_active == 3) then
    refresh_active = 0
  elseif (refresh_active == 0) then
    refresh_active = 1
    mapargs["context_event_data"] = {id=pascal_Display_ID.PO_MACHINE_WARNING, len=4, b1=0x02, b2=0x00, b3=0x00, b4=0x00}
    pascal_receive(mapargs)
--    gui_state = cGUI_STATE_WARNING_MODE
    gui_state = cGUI_STATE_ERROR_MODE
--    mapargs["context_event_data"] = {id=pascal_Display_ID.PO_MACHINE_FAULT, len=8, b1=0x20, b2=0x00, b3=0x00, b4=0x00,
--                                                                                   b5=0x00, b6=0x00, b7=0x00, b8=0x00}
--    pascal_receive(mapargs)
  elseif (refresh_active == 1) then
    --refresh_active = 0
    --mapargs["context_event_data"] = {id=pascal_Display_ID.PO_MACHINE_FAULT, len=4, b1=0x00, b2=0x08, b3=0x00, b4=0x00}
    --pascal_receive(mapargs)
  end
  refresh_timer = gre.timer_set_timeout(simulate_machine_refresh, 6000)
end

function simulate_status_updates(mapargs)
  local mapargs = {}
  local ecell_value = 0
  local manifold_value = 0
  local ph_value = 0
  
  if status_timer ~= nil then
    gre.timer_clear_interval(status_timer) --Ensure there is only one timer running
    status_timer = nil
  end
  
  if status_index == 0 then
    status_index = 1
    ecell_value = 100
    manifold_value = 5
    ph_value = 50    
  elseif status_index == 1 then
    status_index = 2
    ecell_value = 70
    manifold_value = 15
    ph_value = 30   
  elseif status_index == 2 then
    status_index = 3
     ecell_value = 40
    manifold_value = 60
    ph_value = 70      
  elseif status_index == 3 then
    status_index = 0
    ecell_value = 20
    manifold_value = 100
    ph_value = 100
  end
  
  status_timer = gre.timer_set_timeout(simulate_status_updates, 2000)
  
  
  -- simulate ecell, manifold, and ph percents
  mapargs["context_event_data"] = {id=pascal_Display_ID.PO_ECELL_PERCENT, len=1, b1=ecell_value}
  pascal_receive(mapargs)
  mapargs["context_event_data"] = {id=pascal_Display_ID.PO_MANIFOLD_PERCENT, len=1, b1=manifold_value}
  pascal_receive(mapargs)
  mapargs["context_event_data"] = {id=pascal_Display_ID.PO_PH_PERCENT, len=1, b1=ph_value}
  pascal_receive(mapargs)

end

function machine_simulator(message, data)
	print("received message "..string.format("%x",message))
	if type(message_handlers[message]) == "function" then
		message_handlers[message](data)
	end
end
