
local callback_function_table = {}

local cPASCAL_DATA_EVENT = "pascal_message"

function register_cb(msg_id, cb_function)
	if type(cb_function) == "function" then
		callback_function_table[msg_id] = cb_function
	else
		print("WARNING: Callback Register Failed!")
	end
end

function pascal_receive(mapargs)
	local eventMSG = mapargs["context_event_data"]
	local event_Data = {}
	
	--Do callback to process message
	local cb_func = callback_function_table[eventMSG.id]

  --Fill data table array
	for i=1,eventMSG.len do
    local i_string = "b"..tostring(i)
    event_Data[i] = eventMSG[i_string]
  end
	
	--Callback function, if available
	if type(cb_func) == "function" then
		--print("DEBUG: Processing Event: "..tostring(eventMSG.id))
		cb_func(event_Data)
	else
		print("WARNING: No Callback Function Found for Event: "..tostring(eventMSG.id))
	end
end

function pascal_send(msg_id, msg_payload)

	local format_string = "2u1 id 2u1 len"
	
	local data_table = {}
	
	data_table["id"] = msg_id
	data_table["len"] = #msg_payload

	for i,v in ipairs(msg_payload) do
		local itr_string = "b"..tostring(i)
		format_string = format_string.." 1u1 "..itr_string
		data_table[itr_string] = v
	end
	gre.send_event_data(cPASCAL_DATA_EVENT, format_string, data_table, "pascal_IN")
	if gre.env("target_os") == "win32" then
		machine_simulator(msg_id, msg_payload)
	end
end

