--[[ 
@page revisionpage Revision History
revision.h
File tracks the project revision history and maintains the constants.
Copyright (c) 2017, Tennant Company
                    701 North Lilac Drive
                    P.O. Box 1452
                    Minneapolis, MN 55440
<th>REVISION HISTORY (latest at the top): </th>
<table border>
<tr>
  <td>05.17.2018</td>
  <td>0.14</td>
  <td> Fixed error icon display bug
  </td>
</tr>
<tr>
  <td>05.17.2018</td>
  <td>0.13</td>
  <td> Added several new error codes.  Updated error code functions to allow 64-bit 
       error codes.  Removed unused error codes.
  </td>
</tr>
<tr>
  <td>04.10.2018</td>
  <td>0.12</td>
  <td> Added SYS200 error
  </td>
</tr>
<tr>
  <td>02.09.2018</td>
  <td>0.11</td>
  <td> Swapped Anolyte and Catholyte tank graphic locations
  </td>
</tr>
<tr>
  <td>10.26.2017</td>
  <td>0.10</td>
  <td> Anolyte and Catholyte switch statuses on Status_screen default to "Not Full" and 
       "Not Empty"
  </td>
</tr>
<tr>
  <td>10.23.2017</td>
  <td>0.09</td>
  <td> each screen now has its own "bottom_buttons_" layer, deleted unneccessary buttons
       from each "bottom_buttons_" layer
  </td>
</tr>
<tr>
  <td>10.20.2017</td>
  <td>0.08</td>
  <td> Updated GUI_STATE and APP_STATE enumerations, refactored do_app_state callback
       to handle screen transitions in the case of an Error or Warning.
       Redesigned flashing warning icon process to eliminate an error when clearing 
       a timer associated with it.  display_machine_fault and display_machine_warning
       callbacks no longer trigger screen transitions.
  </td>
</tr>
<tr>
  <td>10.06.2017</td>
  <td>0.07</td>
  <td> Initialize anolyte_tank_full_switch_status to 0 instead of 1
  </td>
</tr>
<tr>
  <td>09.27.2017</td>
  <td>0.06</td>
  <td> Removed "2nd Bootloader: NOT PRESENT" from Service Screen
  </td>
</tr>
<tr>
  <td>08.11.2017</td>
  <td>0.05</td>
  <td>updated fault string. cleaned up some of the icons
  </td>
</tr>
<tr>
  <td>07.27.2017</td>
  <td>0.04</td>
  <td>Cleaned up fault screen.  Added new faults
  </td>
</tr>
<tr>
  <td>07.21.2017</td>
  <td>0.03</td>
  <td>Added wear alerts. cleaned up screen translations
  </td>
</tr>
<tr>
  <td>07.17.2017</td>
  <td>0.02</td>
  <td>Updated service screens.  Added faults and warnings.
  </td>
</tr>
<tr>
  <td>06.07.2017</td>
  <td>0.01</td>
  <td>Initial checkin of Nemo LCD code
  </td>
</tr>
</table>
--------------------------------------------------------------------------------------------------]]

--! Major value of the current firmware revision. --
cREVISION_MAJOR = 0

--! Minor value of the current firmware revision. --
cREVISION_MINOR = 14

---- Assumes major revision won't get above 9. --
cREVISION_STRING = string.format("%d", cREVISION_MAJOR)..'.'..string.format("%02d", cREVISION_MINOR)

---- String description of the project --
cSTRING_DESCRIPTION = "OS3 Interface"
