local screen_stack = {}
local logout_counter = 0
local service_screen_index = 0

cSERVICE_SCREEN_STARTUP = 1
cSERVICE_SCREEN_NAVIGATE = 2
cSERVICE_SCREEN_EXIT = 3

function goto_menu_screen(mapargs) 
	local data = {}

	data["screen_name"] = mapargs.menu_screen
	
	gre.set_data(data)
	gre.send_event("change_screen")
end

function switch_menu_screen(mapargs)
	local data = {}
	
	table.insert(screen_stack, mapargs.context_screen)
	
	data["screen_name"] = mapargs.menu_screen
	
	gre.set_data(data)
	
	gre.send_event("change_screen")
end

function go_home(mapargs)
	local data = {}
  local msg_data = {}

  if gui_state == cGUI_STATE_INITIALIZING or gui_state == cGUI_STATE_WAITING then
    data["screen_name"] = "Wait_screen"
  elseif gui_state == cGUI_STATE_GEN_SOLUTION then
    data["screen_name"] = "Regen_Screen"
  elseif gui_state == cGUI_STATE_ERROR_MODE or gui_state == cGUI_STATE_WARNING_MODE then
    data["screen_name"] = "Warning_screen" 
  else 
  	data["screen_name"] = "Home_screen"
	end
	gre.set_data(data)
	
	
	screen_index = 0
	screen_stack = {}
	
	setup_home_screen() 
  
  msg_data = int_to_bytes(0, 2)
  pascal_send(pascal_Input_ID.PA_HOME_BUTTON, msg_data)
	

	gre.send_event("change_screen")
end

function go_back_screen(mapargs)
	local data = {}
	if #screen_stack > 0 then
		data["screen_name"] = table.remove(screen_stack)
		gre.set_data(data)
				
		if mapargs.back_count and mapargs.back_count > 1 then
			mapargs.back_count = mapargs.back_count - 1
			go_back_screen(mapargs)
		else
			gre.send_event("change_screen")
		end
	end
end

function calibrate_touchscreen(mapargs)
	local target_os = gre.env("target_os")
	gre.send_event("hold_screen")
	if(target_os == "linux") then
		os.execute("/opt/storyboard/bin/sbengine -otslib,calibrate ts_calib.gapp")
	else
		os.execute([["C:\Program Files (x86)\Crank Software\Storyboard_Engine\3.2.201311151607\win32-x86-opengles_2.0-obj\bin\sbengine.exe" ts_calib.gapp]])
	end
	gre.send_event("release_screen")
	gre.redraw(0,0,0,0)
	go_home()
end

function verify_touchscreen(mapargs)
	local target_os = gre.env("target_os")
	gre.send_event("hold_screen")
	if(target_os == "linux") then
		os.execute("/usr/bin/ts_test")
	end
	gre.send_event("release_screen")
	gre.redraw(0,0,0,0)
end

function navigate_service_screen(mapargs) 
  local data = {}
  
  if (mapargs.direction == "forward") then
    service_screen_index = service_screen_index + 1
    if service_screen_index > 10 then
      service_screen_index = 1
    end
  else
    service_screen_index = service_screen_index - 1
    if service_screen_index < 1 then
      service_screen_index = 10
    end
  end
  
  
  local msg_data = int_to_bytes(cPASCAL_SERVICE_SCREEN, 2)
  msg_data[#msg_data+1] = cSERVICE_SCREEN_NAVIGATE
  msg_data[#msg_data+1] = service_screen_index
  pascal_send(pascal_Input_ID.PA_APP_REQUEST, msg_data) 
  
  update_service_screen()
  
  gre.set_data(data)
end

function setup_service_screen(mapargs)
  service_screen_index = 1
  
  local msg_data = int_to_bytes(cPASCAL_SERVICE_SCREEN, 2)
  msg_data[#msg_data+1] = cSERVICE_SCREEN_NAVIGATE
  msg_data[#msg_data+1] = service_screen_index
  pascal_send(pascal_Input_ID.PA_APP_REQUEST, msg_data)  
  
  update_service_screen()
  
end

function cleanup_service_screen(mapargs)
  local msg_data = int_to_bytes(cPASCAL_SERVICE_SCREEN, 2)
  msg_data[#msg_data+1] = cSERVICE_SCREEN_EXIT
  pascal_send(pascal_Input_ID.PA_APP_REQUEST, msg_data)  
end


function setup_quantity_dispensed_screen(mapargs)
  cycle_quantity_dispensed_screen(mapargs)
  
end

function hide_quantity_dispensed_screen(mapargs)
  stop_quantity_dispensed_screen()
end

function setup_status_screen(mapargs)
  info_button(mapargs) 
end

function setup_warning_screen(mapargs)
--  local data = {}
--  
--  if gui_state == cGUI_STATE_WARNING_MODE then
--    gre.send_event("flash_warning")
--    print("FLASH!")
--  else
--  gre.send_event("flash_warning_stop")
--    print("DON'T FLASH")  
--  end
--  
--  
--  data["warning_layer.warning_icon.grd_hidden"] = 0  
--  data["warning_layer.fault_code.grd_hidden"] = 0
--  
--  gre.set_data(data)
--  print("Show Warning Screen")
end

function hide_warning_screen(mapargs)
--  gre.send_event("flash_warning_stop")
--  print("flash_warning_stop")
--  print("Hide Warning Screen")
end

function setup_wait_screen(mapargs) 

end

function update_service_screen(mapargs)
  local data = {}
  
  for i=1, 11 do
    if i == service_screen_index then
      data[string.format("Service_screen.service_page_%d.grd_hidden",i)] = 0
    else
      data[string.format("Service_screen.service_page_%d.grd_hidden",i)] = 1
    end
  end
  
  gre.set_data(data)

end

function exit_screen(mapargs) 
  local msg_data = int_to_bytes(0, 1)
  local data = {}
  
  pascal_send(pascal_Input_ID.PA_SCREEN_BUTTON, msg_data)
  
  data["screen_name"] = "Quantity_dispensed_screen"
  
  gre.set_data(data)
  
  gre.send_event("change_screen")
end

function info_button(mapargs) 
  local msg_data = int_to_bytes(0, 1)
  pascal_send(pascal_Input_ID.PA_INFO_BUTTON, msg_data)
end

function setup_gen_sol_screen(mapargs) 
  local data = {}
  
  data["sol_gen_layer.catholyte_hand.grd_hidden"] = 1
  data["sol_gen_layer.anolyte_hand.grd_hidden"] = 1
  data["sol_gen_layer.catholyte_tank.grd_hidden"] = 0
  data["sol_gen_layer.anolyte_tank.grd_hidden"] = 0
  
  data["sol_gen_layer.catholyte_tank.image"] = "images/catholyte_solution_level_3.png"
  data["sol_gen_layer.anolyte_tank.image"] = "images/anolyte_solution_level_3.png"
  
  gre.set_data(data)
    

end

function setup_regen_screen(mapargs) 
  local data = {}
  
  data["sol_gen_layer.catholyte_hand.grd_hidden"] = 1
  data["sol_gen_layer.anolyte_hand.grd_hidden"] = 1
  data["sol_gen_layer.catholyte_tank.grd_hidden"] = 0
  data["sol_gen_layer.anolyte_tank.grd_hidden"] = 0
  
  data["sol_gen_layer.catholyte_tank.image"] = "images/catholyte_solution_level_3.png"
  data["sol_gen_layer.anolyte_tank.image"] = "images/anolyte_solution_level_3.png"
  
  gre.set_data(data)
  

end

function reset_ph_wear(mapargs) 
  local data = {}
  data = int_to_bytes(0, 1)
  pascal_send(pascal_Input_ID.PA_PH_WEAR_RESET, data)
end

function reset_ecell_wear(mapargs) 
  local data = {}
  data = int_to_bytes(0, 1)
  pascal_send(pascal_Input_ID.PA_ECELL_WEAR_RESET, data)
end

function reset_manifold_wear(mapargs) 
  local data = {}
  data = int_to_bytes(0, 1)
  pascal_send(pascal_Input_ID.PA_MANIFOLD_WEAR_RESET, data)
end


function setup_home_screen(mapargs) 
  local data = {}

  if get_component_wear_code() == cECELL_WEAR_CODE then
    data["bottom_buttons_home.wear_icon.image"] = "images/ecell_icon.png"
    data["bottom_buttons_home.wear_icon.text"] = ""
  elseif get_component_wear_code() == cMAN_WEAR_CODE then
    data["bottom_buttons_home.wear_icon.image"] = "images/manifold_icon.png"
    data["bottom_buttons_home.wear_icon.text"] = ""
  elseif get_component_wear_code() == cPH_WEAR_CODE then
    data["bottom_buttons_home.wear_icon.image"] = ""
    data["bottom_buttons_home.wear_icon.text"] = "pH"
  else
    data["bottom_buttons_home.wear_icon.image"] = ""
    data["bottom_buttons_home.wear_icon.text"] = ""      
  end  
      
      
  if get_component_wear_code() == cNO_WEAR_CODE_ACTIVE then    
    data["bottom_buttons_home.wear_icon.grd_hidden"] = 1
    data["bottom_buttons_home.alert_button.grd_hidden"] = 1
  else
    data["bottom_buttons_home.wear_icon.grd_hidden"] = 0
    data["bottom_buttons_home.alert_button.grd_hidden"] = 0
  end

  gre.set_data(data)
end
