math.randomseed(os.time())

function intdiv(a, b)
    q = a/b
    return (q > 0) and math.floor(q) or math.ceil(q)
end

function bytes_to_int(array)
  local number = 0
    for k=1,#array do
        number = number + array[k]*2^((k-1)*8)
    end
  return number
end


function int_to_bytes(number, num_bytes)
  local num = number
    local result = {}
    local n = num_bytes -- number of bytes to be used.
    for k=n,1,-1 do
        local mul=2^(8*(k-1)) -- 256 = 2^8 bits per char.
        result[k]=math.floor(num/mul)
        num=num-result[k]*mul
    end
  return result
end

function exit_app(mapargs)
  gre.quit()
end

function calc_Height(str, font, font_size, max_width)
   
   local strsize = gre.get_string_size(font, font_size, "H", 0)
   local dh = strsize["line_height"]
   local Height = dh
   local row_length = 0
   
   for i = 1, #str do
       local c = str:sub(i,i)
       strsize = gre.get_string_size(font, font_size, tostring(c), 0)
       if c == '\n' or
           row_length >= max_width then
          row_length = 0
          Height = Height + dh
       else
          row_length = row_length + strsize["width"] -- char width
       end
    end
   return Height
end

function tprint (tbl, indent)
  if not indent then indent = 0 end
  for k, v in pairs(tbl) do
    formatting = string.rep("  ", indent) .. k .. ": "
    if type(v) == "table" then
      print(formatting)
      tprint(v, indent+1)
    elseif type(v) == 'boolean' then
      print(formatting .. tostring(v))    
    else
      print(formatting .. v)
    end
  end
end
